## ⏱ 2024/03/30
### 📢 Update 27 papers!

```

    https://doccano.github.io/doccano/tutorial/

    https://github.com/urchade/ATG

    https://medium.com/@alvarani/reviewing-ner-spacy-vs-gliner-d2e9ee331270

    


```

### Entity Identification & Typing
|  Paper  |  Paradigm  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [Embedded Named Entity Recognition using Probing Classifiers](https://arxiv.org/abs/2403.11747) | Supervised Fine-tuning | Arxiv | 2024-03 | [GitHub](https://github.com/nicpopovic/EMBER) |
| [ProgGen: Generating Named Entity Recognition Datasets Step-by-step with Self-Reflexive Large Language Models](https://arxiv.org/abs/2403.11103) | Inverse Generation | Arxiv | 2024-03 | [GitHub](https://github.com/StefanHeng/ProgGen) |
| [Rethinking Negative Instances for Generative Named Entity Recognition](https://arxiv.org/abs/2402.16602) | Supervised Fine-tuning、Cross-Domain Learning | Arxiv | 2024-02 | [GitHub](https://github.com/yyDing1/GNER) |
| [NuNER: Entity Recognition Encoder Pre-training via LLM-Annotated Data](https://arxiv.org/abs/2402.15343) | Data Annotation | Arxiv | 2024-02 | 
| [VerifiNER: Verification-augmented NER via Knowledge-grounded Reasoning with Large Language Models](https://arxiv.org/abs/2402.18374) | Data Annotation | Arxiv | 2024-02 | 
| [A Simple but Effective Approach to Improve Structured Language Model Output for Information Extraction](https://arxiv.org/abs/2402.13364) | Zero-shot Prompting | Arxiv | 2024-02 | 
| [PaDeLLM-NER: Parallel Decoding in Large Language Models for Named Entity Recognition](https://arxiv.org/abs/2402.04838) | Supervised Fine-tuning | Arxiv | 2024-02 |
| [ConsistNER: Towards Instructive NER Demonstrations for LLMs with the Consistency of Ontology and Context](https://ojs.aaai.org/index.php/AAAI/article/view/29892)| In-Context Learning | AAAI | 2024-03 | 
| [NAG-NER: a Unified Non-Autoregressive Generation Framework for Various NER Tasks](https://aclanthology.org/2023.acl-industry.65/) | Supervised Fine-tuning | ACL Industry | 2023-07 | 
| [Unified Named Entity Recognition as Multi-Label Sequence Generation](https://ieeexplore.ieee.org/abstract/document/10191921) | Supervised Fine-tuning | IJCNN | 2023-06 | 



### Relation Classification
|  Paper  |  Paradigm  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [Mastering the Task of Open Information Extraction with Large Language Models and Consistent Reasoning Environment](https://arxiv.org/abs/2310.10590) | In-Context Learning | Arxiv | 2023-10 | 
| [Sequence generation with label augmentation for relation extraction](https://ojs.aaai.org/index.php/AAAI/article/view/26532)| Supervised Fine-tuning | AAAI | 2023-06 | [GitHub](https://github.com/pkuserc/RELA) |
| [DORE: Document Ordered Relation Extraction based on Generative Framework](https://aclanthology.org/2022.findings-emnlp.253/) | Supervised Fine-tuning | EMNLP Findings | 2022-12 |

### Relation Triplet
|  Paper  |  Paradigm  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [ERA-CoT: Improving Chain-of-Thought through Entity Relationship Analysis](https://arxiv.org/abs/2403.06932) | Zero-shot Prompting | Arxiv | 2024-03 | [GitHub](https://github.com/OceannTwT/era-cot) |
| [A Simple but Effective Approach to Improve Structured Language Model Output for Information Extraction](https://arxiv.org/abs/2402.13364) | Zero-shot Prompting | Arxiv | 2024-02 | 
| [AutoRE: Document-Level Relation Extraction with Large Language Models](https://arxiv.org/abs/2403.14888) | Supervised Fine-tuning | Arxiv | 2024-03 | [GitHub](https://github.com/bigdante/AutoRE) |
| [Mastering the Task of Open Information Extraction with Large Language Models and Consistent Reasoning Environment](https://arxiv.org/abs/2310.10590) | In-Context Learning | Arxiv | 2023-10 | 
| [Efficient Data Learning for Open Information Extraction with Pre-trained Language Models](https://aclanthology.org/2023.findings-emnlp.869/) | Supervised Fine-tuning | EMNLP Findings | 2023-12 | 
| [Consistency Guided Knowledge Retrieval and Denoising in LLMs for Zero-shot Document-level Relation Triplet Extraction](https://arxiv.org/abs/2401.13598) | Knowledge Retrival | WWW | 2024 |

### Relation Strict
|  Paper  |  Paradigm  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [An Autoregressive Text-to-Graph Framework for Joint Entity and Relation Extraction](https://ojs.aaai.org/index.php/AAAI/article/view/29919) | Supervised Fine-tuning | AAAI | 2024 | [GitHub](https://github.com/urchade/ATG) |

### Event Detection
|  Paper  |  Paradigm  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [Mastering the Task of Open Information Extraction with Large Language Models and Consistent Reasoning Environment](https://arxiv.org/abs/2310.10590) | In-Context Learning | Arxiv | 2023-10 | 


### Universal Information Extraction
|  Paper  |  Type  |  Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: | :------: |
| [KnowCoder: Coding Structured Knowledge into LLMs for Universal Information Extraction](https://arxiv.org/abs/2403.07969) | Code-LLMs based | Arxiv | 2024-03 | [GitHub](https://ict-goknow.github.io/knowcoder/) |

### Specific Domains
|  Paper  |   Domain  |   Venue  |  Date  |  Code  |
| :------ |  :------: | :------: | :------: | :------: |
| [Advancing Entity Recognition in Biomedicine via Instruction Tuning of Large Language Models]() | Biomedical | Bioinformatics | 2024-03 | [GitHub](https://github.com/BIDS-Xu-Lab/BioNER-LLaMA) |
| [Structured information extraction from scientific text with large language models](https://www.nature.com/articles/s41467-024-45563-x) | Scientific | Nature Communications | 2024-02 | [GitHub](https://github.com/LBNLP/NERRE) |
| [Combining prompt‑based language models and weak supervision for labeling named entity recognition on legal documents](https://link.springer.com/article/10.1007/s10506-023-09388-1) | Legal | Artificial Intelligence and Law  | 2024-02 | 
| [Impact of Sample Selection on In-Context Learning for Entity Extraction from Scientific Writing](https://aclanthology.org/2023.findings-emnlp.338/)| Scientific | EMNLP Findings | 2023-12 | [GitHub](https://github.com/adalin16/ICL_EE)|
| [Improving LLM-Based Health Information Extraction with In-Context Learning](https://link.springer.com/chapter/10.1007/978-981-97-1717-0_4)| Health | Health Information Processing.Evaluation Track Papers | 2024-03 |

### Evaluation and Analysis
|  Paper  |   Venue  |  Date  |  Code  |
| :------ | :------: | :------: | :------: |
| [IEPile: Unearthing Large-Scale Schema-Based Information Extraction Corpus]() | Arxiv | 2024-02 | [GitHub](https://github.com/zjunlp/IEPile?tab=readme-ov-file) |
| [Few shot clinical entity recognition in three languages: Masked language models outperform LLM prompting](https://arxiv.org/abs/2402.12801) | Arxiv | 2024-02 | 
| [Information Extraction from Legal Wills: How Well Does GPT-4 Do?](https://aclanthology.org/2023.findings-emnlp.287/) | EMNLP Findings | 2023-12 | [GitHub](https://github.com/ml4ai/ie4wills/) |
