# Deep-Learning-Tensorflow

Gathers Tensorflow deep learning projects.

<img src="https://upload.wikimedia.org/wikipedia/commons/thumb/2/2d/Tensorflow_logo.svg/2000px-Tensorflow_logo.svg.png" align="right" width="20%">

## Table of contents
  * [Convolutional Neural Network](https://github.com/huseinzol05/Deep-Learning-Tensorflow#convolutional-neural-network)
  * [Feed-forward Neural Network](https://github.com/huseinzol05/Deep-Learning-Tensorflow#feed-forward-neural-network)
  * [Recurrent Neural Network](https://github.com/huseinzol05/Deep-Learning-Tensorflow#recurrent-neural-network)
  * [Attention API](https://github.com/huseinzol05/Deep-Learning-Tensorflow#attention-api)
  * [Sequence-to-Sequence](https://github.com/huseinzol05/Deep-Learning-Tensorflow#sequence-to-sequence)
  * [Hybrid Model](https://github.com/huseinzol05/Deep-Learning-Tensorflow#hybrid-model)
  * [Bayesian Hyperparameter Optimization](https://github.com/huseinzol05/Deep-Learning-Tensorflow#bayesian-hyperparameter-optimization)
  * [Regression](https://github.com/huseinzol05/Deep-Learning-Tensorflow#regression)
  * [Reinforcement-learning](https://github.com/huseinzol05/Deep-Learning-Tensorflow#reinforcement-learning)
  * [Distributed](https://github.com/huseinzol05/Deep-Learning-Tensorflow#distributed)
  * [Miscellaneous](https://github.com/huseinzol05/Deep-Learning-Tensorflow#miscellaneous)
  * [Generative Adversarial Network](https://github.com/huseinzol05/Deep-Learning-Tensorflow#generative-adversarial-network)

### Convolutional Neural Network

1. Scratch Alex-net CIFAR 10
2. Capsule Network
3. Encoder-Decoder
4. Residual Network
5. Basic Conv on MNIST
6. Byte-Net Translator
7. Siamese Network on MNIST
8. Generalized Hamming Network on MNIST
9. Binary-net
10. Kmax Conv1d
11. Temporal Conv1d
12. Triplet loss on MNIST
13. Dense-net
14. U-net

### Feed-forward Neural Network

1. Batch-normalization
2. Encoder-Decoder
3. Word Vector
4. Dropout Comparison, GIF included
5. L1, L2, L1-L2 Regularization Comparison, GIF included
6. Optimizer Comparison (Gradient Descent, Adagrad, RMSProp, Adam), GIF included
7. Batch-normalization Comparison, GIF included
8. Self-Normalized without and with API on MNIST
9. Addsign and Powersign Optimizer
10. Backprop without Learning Rates Through Coin Betting Optimizer (COCOB)

### Recurrent Neural Network

1. Music Generator
2. Stock forecasting, GIF included
3. Text Generator
4. [Signal Classifier](https://github.com/huseinzol05/Signal-Classification-Comparison)
5. Generator Comparison (LSTM GRU, LSTM Bidirectional, GRU Bidirectional), GIF included
6. Time-Aware Long-Short Term Memory
7. Dilated RNN
8. Layer-Norm LSTM
9. Neural Turing Machine
10. Only Attention
11. Multihead Attention
12. Fast-slow LSTM
13. Siamese Network
14. Nested LSTM
15. DNC (Differentiable Neural Computer)
16. Simple Recurrent Unit

### Attention API

1. Bahdanau
2. Luong
3. Hierarchical
4. Additive
5. Soft
6. Attention-over-Attention
7. Bahdanau API
8. Luong API

### Sequence-to-Sequence

1. Basic Seq-to-Seq
2. Beam decoder
3. Chatbot with Attention (old API)
4. Summarization with Attention (old API)
5. Luong attention
6. Bahdanau attention
7. Bidirectional
8. Estimator
9. Altimatum (bidirectional + lstm + luong + beam)

### Hybrid Model

1. CNN + LSTM RNN for OCR
2. GAN Sentence

### Bayesian Hyperparameter Optimization

1. Conv-CIFAR10
2. Feedforward-Iris
3. Recurrent-Sentiment
4. Conv-Iceberg

#### Regression

1. Linear Regression, GIF included
2. Polynomial Regression, GIF included
3. Ridge Regression, GIF included
4. Lasso Regression, GIF included
5. Elastic-net Regression, GIF included
6. Sigmoid Regression, GIF included
7. Quantile Regression

### [Reinforcement-learning](https://github.com/huseinzol05/Reinforcement-Learning-Agents)

1. Policy gradient
2. Q-learning
3. Double Q-learning
4. Recurrent-Q-learning
5. Double Recurrent-Q-learning
6. Dueling Q-learning
7. Dueling Recurrent-Q-learning
8. Double Dueling Q-learning
9. Double Dueling Recurrent-Q-learning
10. Actor-Critic
11. Actor-Critic Dueling
12. Actor-Critic Recurrent
13. Actor-Critic Dueling Recurrent
14. Async Q-learning

### Distributed

1. TF-Distributed
2. Sparkflow
3. Dask Tensorflow

### Miscellaneous

1. RNN-LSTM 20newsgroup Tensorboard histrogram
2. Tensorboard debugger
3. Transfer learning emotion dataset on MobilenetV2
4. Multiprocessing tfrecords
5. TF-Serving
6. Renaming checkpoint
7. Load Tensorflow Slim Checkpoint
8. Observed how Inception learned

### Generative Adversarial Network

1. DCGAN
2. DiscoGAN
3. Basic GAN
4. WGAN-improve
